#ifndef __FUCKGNOME_H
#define __FUCKGNOME_H

typedef struct {
   int button_number;
   int close_id, clicked_id, destroy_id;
   int destroyed;
} DialogRunInfo;

typedef struct {
   char *key;
   char *value;
} Key;

void j_dialog_close(GtkWidget *dialog);
void j_dialog_delete_event(GtkWidget *dialog, GdkEvent *, void **);
void j_dialog_run(GtkWidget *widget, int close_after);
void j_dialog_run_close(GtkWidget *widget, DialogRunInfo *ri);
void j_dialog_show(GtkWidget *dialog, GtkWidget *vbox);
GtkWidget *j_dialog_vbox(GtkWidget *dialog);
void j_dialog_button_connect(GtkWidget *dialog, int button, void *func, void *data);
GtkWidget *j_dialog_new(char *title, ...);
GtkWidget *j_about_new(const char *package, const char *version, const char *copyright, const char **authors, const char *desc, const char *logo);
void j_error_dialog(char *text);
void j_warning_dialog(char *text);
GtkWidget *j_question_dialog(const char *text, GnomeReplyCallback callback, void *data, GtkWindow *parent);
void j_property_box_changed(GtkWidget *widget);
void j_property_box_append_page(GtkWidget *vbox, GtkWidget *label);
GtkWidget *j_property_box_new();
GtkWidget *j_entry_gtk_entry(GtkWidget *widget);
GtkWidget *j_entry_new(char *history);
GtkWidget *j_file_entry_gtk_entry(GtkWidget *widget);
GtkWidget *j_file_entry_new(char *h, char *title);
FILE *open_config(char *flags);
char *construct_key(char *prog, char *h, char *k);
char *breakdown_key(char *key, char **h, char **k, char **v);
char *is_header(char *line);
GList *add_header(GList *keys, char *hdr);
GList *find_key_header(GList *keys, char *h);
GList *add_key(GList *keys, char *h, char *k, char *v);
GList *create_key_list();
Key *find_key(GList *hdr, char *key);
void destroy_key_list(GList *keys);
Key *find_key_in_section(GList *keys, char *hdr, char *k);
char *j_config_access_read(char *key);
void j_config_access_write(char *key, char *s, int i);
void j_config_set_int(char *key, int val);
void j_config_set_string(char *key, char *s);
char *j_config_get_string(char *key);
int j_config_get_int(char *key);
int j_config_has_section(char *key);
void j_config_sync();

#endif /* __FUCKGNOME_H */
