#ifndef __CONNECT_H
#define __CONNECT_H

typedef struct {
   GdkInputFunction orig_cb;
   GdkInputFunction cb;
   void *data;
   GdkInputCondition condition;
   int *sock;
   int *orig_input;
   
   char *username;
   char *password;
   
   int input;
   int instance;
   unsigned long int dest_ip;
   unsigned short int dest_port;
} SocksData;

void socks4_connect(void *, int, GdkInputCondition);
int dispatch_connect(unsigned long int, unsigned short int, int *, int *, GdkInputCondition, void *, void *);

#endif /* __CONNECT_H */
